﻿Ext.define('App.Control.Kivii.Finances.Settlement.Paying.Form', {
    extend: 'System.Control.EntityList',
    xtype: 'App.Control.Kivii.Finances.Settlement.Paying.Form',
    plugins: [{
        ptype: 'cellediting',
        clicksToEdit: 0
    }],
    viewModel: {
        data: {
            owner: {},
            amountSelected: 0,
            SettlementKvids:[]
        }
    },
    tbar: [{
        margin: '0 0 -9 3',
        xtype: 'displayfield',
        bind: {
            value: '{owner.PayerName}(需支付 {owner.Amount-owner.AmountPayment} 元)/已选:{amountSelected}元'
        },
        fieldStyle: {
            fontSize: '16px'
        }
    }, '->', {
        text: '金额补齐',
        iconCls: 'x-fa fa-circle',
        handler: '_onAddDiscountAccount'
    }, {
        text: '收款登记',
        iconCls: 'x-fa fa-tags',
        handler: '_onCreateEntity'
    }],
    dockedItems: [],
    columnLines: true,
    columns: {
        defaults: {
            menuDisabled: true
        },
        items: [{
            xtype: 'rownumberer'
        }, {
            dataIndex: 'PayerName',
            text: '付款单位',
            flex: 1,
            renderer: function(_value, _meta, _record, _rowIndex) {
                if (_record.data.Type === 'Discount') {
                    _meta.style = 'background-color:#FFFFE0';
                }
                return _value;
            }
        }, {
            dataIndex: 'Amount',
            text: '金额',
            align: 'right',
            width: 220
        }, {
            dataIndex: 'AmountBalance',
            text: '余额',
            align: 'right',
            width: 90
        }, {
            xtype: 'actioncolumn',
            width: 100,
            text: '操作',
            align: 'center',
            menuDisabled: true,
            sortable: false,
            items: [{
                getClass: function(_value, _metadata, _record, _rowIndex, _colIndex, _store) {
                    if (_record.data.Kvid === '00000000-0000-0000-0000-000000000000') return 'x-fa fa-plus';
                    else return 'x-fa fa-trash-o';
                },
                handler: '_onAction'
            }]
        }]
    },
    setOwner: function(_entities) {
        let _view = this;
        let _vm = _view.getViewModel();
        let _amount=0;
        let _amountPayment=0;
        let _payerName='';
        let _kvids=[];
        for (let _i = 0; _i < _entities.length; _i++) {
        	var _record=_entities[_i].data;
        	_kvids.push(_record.Kvid);
        	_amount+=_record.Amount;
        	_amountPayment+=_record.AmountPayment;
        	_payerName=_record.PayerName;
        }
        _vm.set('SettlementKvids',_kvids);
    	_vm.set('owner.Amount',parseFloat(_amount.toFixed(2)));
    	_vm.set('owner.AmountPayment',parseFloat(_amountPayment.toFixed(2)));
    	_vm.set('owner.PayerName',_payerName);
        let _empty = {};
        _empty.Kvid = '00000000-0000-0000-0000-000000000000';
        _view.addEntity(_empty);
    },
    controller: {
        _onAction: function(_ctrl, _rowIndex, _colIndex, _item, _e, _record) {
            let _controller = this;
            let _vm = _controller.getViewModel();
            let _view = _controller.getView();
            let _store = _view.getStore();
            let _records = _store.getData().items;
            let _amountSelected = 0.0;
            for (let _i = 0; _i < _records.length; _i++) {
                if (_records[_i].data.Kvid === '00000000-0000-0000-0000-000000000000') continue;
                _amountSelected += parseFloat(_records[_i].data.Amount);
            }
            if (_record.data.Kvid !== '00000000-0000-0000-0000-000000000000') {
                _view.removeEntity(_record.data);
                _amountSelected -= parseFloat(_record.data.Amount);
                _vm.set('amountSelected', _amountSelected.toFixed(2));
                return;
            }
            let _amountNeed = parseFloat((parseFloat(_vm.data.owner.Amount) - parseFloat(_vm.data.owner.AmountPayment) - parseFloat(_amountSelected)).toFixed(2));
            if (_amountNeed <= 0) {
                Ext.toast("金额已满足支付!");
                return;
            }
            let _selector = Ext.create('App.Control.Kivii.Finances.Paying.Payment.Selector');

            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                title: '选择收款',
                iconCls: _ctrl.iconCls,
                iconAlign: 'left',
                autoScroll: true,
                width: 800,
                height: 400,
                modal: true,
                resizable: false,
                items: [_selector]
            });
            _win.show();
            _selector.setOwner(_vm.data.owner);
            _selector.on('entitySelected', function(_ctrl, _entity) {
                _win.close();
                for (let _i = 0; _i < _records.length; _i++) {
                    if (_entity[0].Kvid === _records[_i].data.Kvid) {
                        _amountSelected -= parseFloat(_records[_i].data.Amount);
                        _vm.set('amountSelected', _amountSelected.toFixed(2));
                        _view.removeEntity(_records[_i].data);
                    }
                }
                _amountNeed = parseFloat((parseFloat(_vm.data.owner.Amount) - parseFloat(_vm.data.owner.AmountPayment) - parseFloat(_amountSelected)).toFixed(2));
                let _amountCanUsed = parseFloat(_entity[0].Amount) - parseFloat(_entity[0].AmountUsed);

                let _amount = _amountNeed <= _amountCanUsed ? _amountNeed : _amountCanUsed;
                let _amountBalance = _amountCanUsed - parseFloat(_amount);
                let _item = {};
                _item.PayerName = _entity[0].PayerName;
                _item.PayKvid = _entity[0].Kvid;
                _item.Amount = _amount.toFixed(2);
                _item.AmountBalance = _amountBalance.toFixed(2);
                _item.Kvid = _entity[0].Kvid;
                _item.Type = 'Payment';

                _view.addEntity(_item, _records.length - 1);
                _vm.set('amountSelected', (_amountSelected + _amount).toFixed(2));
            });
        },

        _onAddDiscountAccount: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _msg = Ext.create('Ext.window.MessageBox', {
                iconCls: _ctrl.iconCls,
                iconAlign: 'left',
                closeAction: 'destroy'
            });
            _msg.confirm('金额补齐', '金额补齐功能 仅适用于客户并未按账单缴费,在交涉后意见达成一致,客户不再补齐.</br>补齐金额过大,可能会影响到绩效考核!确认剩余金额进行补齐操作?', _controller.beforeAddDiscountAccount, _controller);
        },
        beforeAddDiscountAccount: function(_ctrl) {
            if (_ctrl != "yes") return;
            Ext.MessageBox.show({
                title: '补齐折扣',
                msg: '原因:',
                width: 300,
                buttons: Ext.MessageBox.OKCANCEL,
                multiline: true,
                scope: this,
                fn: this._showResultText,
                animateTarget: _ctrl
            });
        },
        _showResultText: function(_btn, _text, _ctrl) {
            if (_btn != "ok") return;
            if (_text === null || _text === "") {
                Ext.toast("请填写少收金额的原因!");
                return;
            }
            let _controller = this;
            let _vm = _controller.getViewModel();
            let _view = _controller.getView();
            let _store = _view.getStore();
            let _records = _store.getData().items;
            let _amountSelected = 0.0;
            for (let _i = 0; _i < _records.length; _i++) {
                if (_records[_i].data.Kvid === '00000000-0000-0000-0000-000000000000') continue;
                _amountSelected += parseFloat(_records[_i].data.Amount);
            }
            let _amountNeed = parseFloat((parseFloat(_vm.data.owner.Amount) - parseFloat(_vm.data.owner.AmountPayment) - parseFloat(_amountSelected)).toFixed(2));
            if (_amountNeed <= 0) {
                Ext.toast("金额已满足支付!");
                return;
            }
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.Account/Query.json',
                jsonData: {
                    OwnerKvid: KiviiContext.CurrentMember.DepartmentKvid,
                    Type: 'Discount'
                },
                success: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    if (_rtns.Results.length !== 1) {
                        Ext.toast('未到对应部门抵扣账户,请联系管理员进行配置!');
                        return;
                    }
                    for (let _i = 0; _i < _records.length; _i++) {
                        if (_rtns.Results[0].Kvid === _records[_i].data.Kvid) {
                            _amountSelected -= parseFloat(_records[_i].data.Amount);
                            _vm.set('amountSelected', _amountSelected.toFixed(2));
                            _view.removeEntity(_records[_i].data);
                        }
                    }
                    let _amount = _amountNeed;
                    let _item = {};
                    _item.PayerName = _vm.data.owner.PayerName + '[部门账户抹零支付]';
                    _item.PayKvid = _rtns.Results[0].Kvid;
                    _item.Amount = _amount.toFixed(2);
                    _item.AmountBalance = 0;
                    _item.Kvid = _rtns.Results[0].Kvid;
                    _item.Type = 'Discount';
                    _item.Remark = _text;
                    _view.addEntity(_item, _records.length - 1);
                    _vm.set('amountSelected', (_amountSelected + _amount).toFixed(2));
                },
                failure: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    Ext.toast(_rtns.ResponseStatus.Message);
                }
            });
        },
        _onCreateEntity: function(_ctrl) {
            let _controller = this;
            let _vm = _controller.getViewModel();
            let _view = _controller.getView();
            let _store = _view.getStore();
            let _records = _store.getData().items;
            if (_records.length <= 1) {
                Ext.toast('请选择至少一个支付!');
                return;
            }
            let _amountNeed = parseFloat(parseFloat(_vm.data.owner.Amount) - parseFloat(_vm.data.owner.AmountPayment));
            let _amountSelected = 0.0;
            let _payMethods = [];
            for (let _i = 0; _i < _records.length; _i++) {
                if (_records[_i].data.Kvid === '00000000-0000-0000-0000-000000000000') continue;
                _amountSelected += parseFloat(_records[_i].data.Amount);
                _payMethods.push(_records[_i].data);
            }
            if (parseFloat(_amountSelected.toFixed(2)) !== _amountNeed) {
                Ext.toast('所选付款总金额:' + _amountSelected + '元,与所需总金额:' + _amountNeed + '元 不相符!请重新选择!');
                return;
            }
            _ctrl.setDisabled(true);
            let _jsonData={};
            _jsonData.SettlementKvids=_vm.data.SettlementKvids;
            _jsonData.PayingMethods=_payMethods;
            _view.mask('正在执行...');
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.Pay/Paying.json',
                jsonData: _jsonData,
                success: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    _ctrl.setDisabled(false);
                    _view.unmask();
            		_view.fireEvent('entityPaying', _view, {});
                },
                failure: function(_response) {
                    _ctrl.setDisabled(false);
                    _view.unmask();
                }
            });
        }
    }
});