﻿Ext.require('App.Const.Finances');
Ext.define('App.View.Kivii.Finances.InvoiceTitle.List',{
    extend: 'System.Control.EntityList',
    xtype: 'App.View.Kivii.Finances.InvoiceTitle.List',
    entityType: 'Kivii.Finances.Entities.InvoiceTitle',
    filter: {
    },
    header: true,
    layout: 'fit',
    title: '发票抬头',
    iconCls: 'x-fa fa-cc',
    viewModel: {
        data: {
            _selection: null,
            lastOwnerKvid: null
        },
    },
    bind: {
        selection: '{_selection}'
    },
    store: {
        autoLoad: true,
        pageSize: 50,
        sorters: [{
            property: 'CreateTime',
            direction: 'DESC'
        }]
    },
    plugins: [{
        ptype: 'cellediting',
        clicksToEdit: 0
    }],
    dockedItems: [{
        xtype: 'toolbar',
        dock: 'top',
        overflowHandler: 'menu',
        items: [{
            xtype: 'searchField',
            flex: 1,
            labelWidth: 60,
            queryField: 'CompanyName',
            emptyText: '模糊搜索公司名称'
        }, {
            text: '新增',
            iconCls: 'x-fa fa-plus',
            iconAlign: 'left',
            handler: '_onAddInvoiceTitle',
        }, {
            text: '详情',
            iconCls: 'x-fa fa-list',
            iconAlign: 'left',
            handler: '_onReadInvoiceTitle',
            bind: {
                disabled: '{!_selection}'
            }
        }, {
            text: '删除',
            iconCls: 'x-fa fa-trash-o',
            iconAlign: 'left',
            handler: '_onDeleteEntity',
            bind: {
                disabled: '{!_selection}'
            }
        }]
    },{
        xtype: 'pagingtoolbar',
        dock: 'bottom',
        displayInfo: true,
        items: [{
            xtype: 'button',
            labelWidth: 60,
            iconCls: 'x-fa fa-check-square-o',
            bind: {
                text: '已选择{selectionCount}条记录,点击清除',
                hidden: '{selectionCount==0}'
            },
            handler: '_onClearSelections'
        }]
    }],
    columns: {
        defaults: {
            menuDisabled: true,
            sortable: true
        },
        items: [{
            xtype: 'rownumberer',
            align: 'center',
        }, {
            text: '公司名称',
            dataIndex: 'CompanyName',
            width: 230
        }, {
            text: '税号',
            dataIndex: 'TaxNumber',
            width: 180
        }, {
            text: '公司地址',
            dataIndex: 'CompanyAddress',
            width:260
        }, {
            text: '电话号码',
            dataIndex: 'Phone',
            width: 120
        }, {
            text: '开户银行',
            dataIndex: 'BankName',
            width: 220
        }, {
            text: '银行账户',
            dataIndex: 'BankAccount',
            width: 150,
            flex:1
        }]
    },
    controller: {
    	_onClearSelections: function() {
            this.getView().clearSelections();
        },
        _onAddInvoiceTitle: function() {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _form = Ext.create('App.Control.Kivii.Finances.InvoiceTitle.Form');
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                // title: _ctrl.text,
                // iconCls: 'x-fa fa-money',
                iconAlign: 'left',
                autoScroll: true,
                width: 560,
                height: 380,
                modal: true,
                resizable: false,
                items: [_form]
            });
            _win.show();
            _form.newEntity();
            _form.on('entityCreated', function(_ctrl, _entity) {
                _win.close();
                _view.reload();
            });
        },
        _onDeleteEntity: function(_ctrl) {
        	let _controller=this;
        	let _view=_controller.getView();
            _view.deleteEntity();
        },
        _onReadInvoiceTitle: function() {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            if (!_view.selection) return;
            let _form = Ext.create('App.Control.Kivii.Finances.InvoiceTitle.Form');
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                // title: _ctrl.text,
                // iconCls: 'x-fa fa-money',
                iconAlign: 'left',
                autoScroll: true,
                width: 560,
                height: 380,
                modal: true,
                resizable: false,
                items: [_form]
            });
            _win.show();
            _form.readEntity(_view.selection.data,true);
            _form.on('entityUpdated', function(_ctrl, _entity) {
                _win.close();
                _view.reload();
            });
        }
    }
});